import { ServiceError } from './error';
import { ServiceEventEmitter } from './event';
import { InferServiceErrors, InferServiceEvents, ServiceInterface } from './service-interface';
import { ServiceModule } from './service-module-registry';
export declare class BaseService<T extends ServiceInterface = any> {
    id: string;
    _emitter: ServiceEventEmitter<any>;
    _modules: {
        [moduleId: string]: ServiceModule;
    };
    constructor();
    error<TErr extends keyof InferServiceErrors<T>>(errorId: TErr, payloads: InferServiceErrors<T>[TErr], inner?: Error): ServiceError<InferServiceErrors<T>[TErr]>;
    emit<TEvt extends keyof InferServiceEvents<T>>(eventId: TEvt, payloads: InferServiceEvents<T>[TEvt]): Promise<void>;
}
//# sourceMappingURL=base-service.d.ts.map