import { MaybeFactory } from '../utils/types';
import { BaseService } from './base-service';
import { ServiceEventEmitter, ServiceEventSubscriber } from './event';
import { ServiceInterface } from './service-interface';
interface ServiceFactory {
    service: MaybeFactory<BaseService>;
    subscriber: MaybeFactory<ServiceEventSubscriber | undefined>;
    emitter: MaybeFactory<ServiceEventEmitter | undefined>;
}
export declare class ServiceRegistry {
    private _factories;
    private _services;
    private _subscribers;
    private _emitters;
    get serviceIds(): string[];
    add(id: string, factory: ServiceFactory): [duplicated: boolean];
    resolveService<T extends ServiceInterface>(id: string): Promise<BaseService<T> | undefined>;
    resolveSubscriber<T extends ServiceInterface>(id: string): Promise<ServiceEventSubscriber<T> | undefined>;
    resolveEmitter<T extends ServiceInterface>(id: string): Promise<ServiceEventEmitter<T> | undefined>;
}
export {};
//# sourceMappingURL=service-registry.d.ts.map