export declare type Entity<TValue> = {
    id: string;
    created: number;
    deleted?: number;
    value?: TValue;
};
interface Events<TValue> {
    CREATED: {
        id: string;
        value: TValue | undefined;
        time: number;
    };
    DELETED: {
        id: string;
        time: number;
    };
    SETTED: {
        id: string;
        value: TValue | undefined;
        time: number;
    };
}
interface Errors<TValue> {
    ACCESS_INVALID_ENTITY: {
        id: string;
    };
    LOOKUP_NON_INDEXED_FIELD: {
        field: keyof TValue;
    };
}
interface Functions<TValue> {
    get(id: string): Promise<Entity<TValue> | undefined>;
    getByIds(ids: string[]): Promise<(Entity<TValue> | undefined)[]>;
}
export declare type EntityManager<TValue> = {
    errors: Errors<TValue>;
    events: Events<TValue>;
    functions: Functions<TValue>;
};
export {};
//# sourceMappingURL=entity.d.ts.map