import { Collection } from 'mongodb';
import { BaseService, Service } from '../../../core';
import * as Interfaces from '../service-interfaces';
declare type MongoDoc<TValue> = {
    _id: string;
    value?: TValue;
};
export interface SingletonEntityManagerOptions {
    id: string;
}
export declare abstract class SingletonEntityManager<TValue extends Record<string, any>> extends BaseService<Interfaces.SingletonEntityManager<TValue>> implements Service<Interfaces.SingletonEntityManager<TValue>> {
    private _module;
    private _id;
    private _collection;
    get collection(): Collection<MongoDoc<TValue>>;
    constructor(options: SingletonEntityManagerOptions);
    get(): Promise<TValue | undefined>;
    protected _set(value: TValue | undefined): Promise<void>;
}
export {};
//# sourceMappingURL=singleton-entity.d.ts.map