import { Collection } from 'mongodb';
export interface CronStorage {
    set(key: string, time: number): Promise<void>;
    get(key: string): Promise<number>;
}
export declare class MemoryStorage implements CronStorage {
    _times: {
        [key: string]: number;
    };
    set(key: string, time: number): Promise<void>;
    get(key: string): Promise<number>;
}
interface MongoDoc {
    _id: string;
    time: number;
}
export declare class MongoStorage implements CronStorage {
    collection: Collection<MongoDoc>;
    constructor(collection: Collection);
    set(key: string, time: number): Promise<void>;
    get(key: string): Promise<number>;
}
export {};
//# sourceMappingURL=storage.d.ts.map