export declare type KeysMatching<T, V> = {
    [K in keyof T]-?: T[K] extends V ? K : never;
}[keyof T];
export declare type MaybePromise<T> = T | Promise<T>;
export declare type Factory<T> = () => MaybePromise<T>;
export declare type MaybeFactory<T> = T | Factory<T>;
export declare type FactoryReturnType<T extends MaybeFactory<any>> = T extends MaybeFactory<infer U> ? U : T;
export declare type DeepReadonly<T> = T extends (infer R)[] ? DeepReadonlyArray<R> : T extends Function ? T : T extends object ? DeepReadonlyObject<T> : T;
interface DeepReadonlyArray<T> extends ReadonlyArray<DeepReadonly<T>> {
}
declare type DeepReadonlyObject<T> = {
    readonly [P in keyof T]: DeepReadonly<T[P]>;
};
export declare type Prettify<T> = T extends object ? {
    [K in keyof T]: Prettify<T[K]>;
} : T;
export {};
//# sourceMappingURL=types.d.ts.map